
uniform float time;
uniform vec2 resolution;
uniform float brightness = 1.0;

float makePoint(float x,float y,float fx,float fy,float sx,float sy,float t){
   float xx=x+2.0*sin(2.0*t*fx)*sx;
   float yy=y+2.0*cos(2.0*t*fy)*sy;
   return brightness/sqrt(xx*xx+yy*yy);
}

void main( void ) {

   vec2 p=(gl_FragCoord.xy/resolution.x)*2.0-vec2(1.0,resolution.y/resolution.x);

   p=p*1.5;
   
   float x=p.x;
   float y=p.y;

   float a=
       makePoint(x,y,3.3,2.9,0.3,0.1,time);
   a=a+makePoint(x,y,1.9,2.0,0.4,0.4,time);
   a=a+makePoint(x,y,0.8,0.7,0.4,0.5,time);
   a=a+makePoint(x,y,2.3,0.1,0.6,0.3,time);
   a=a+makePoint(x,y,0.8,1.7,0.5,0.4,time);
   a=a+makePoint(x,y,0.3,1.0,0.4,0.4,time);
   a=a+makePoint(x,y,1.4,1.7,0.4,0.5,time);
   a=a+makePoint(x,y,1.3,2.1,0.6,0.3,time);
   a=a+makePoint(x,y,1.8,1.7,0.5,0.4,time); 
   a=a+makePoint(x,y,0.5,0.5,0.5,0.5,time);
   a=a+makePoint(x,y,0.5,0.5,0.5,0.5,time);  
   a=a+makePoint(x,y,0.5,0.5,0.5,0.5,time);  
   a=a+makePoint(x,y,0.2,0.7,0.9,0.7,time);    
   
   float b=
       makePoint(x,y,1.2,1.9,0.3,0.3,time);
   b=b+makePoint(x,y,0.7,2.7,0.4,0.4,time);
   b=b+makePoint(x,y,1.4,0.6,0.4,0.5,time);
   b=b+makePoint(x,y,2.6,0.4,0.6,0.3,time);
   b=b+makePoint(x,y,0.7,1.4,0.5,0.4,time);
   b=b+makePoint(x,y,0.7,1.7,0.4,0.4,time);
   b=b+makePoint(x,y,0.8,0.5,0.4,0.5,time);
   b=b+makePoint(x,y,1.4,0.9,0.6,0.3,time);
   b=b+makePoint(x,y,0.7,1.3,0.5,0.4,time);
   b=b+makePoint(x,y,0.8,0.3,0.3,0.1,time);
   b=b+makePoint(x,y,0.4,1.4,1.5,0.4,time);

   float c=
       makePoint(x,y,3.7,0.3,0.3,0.3,time);
   c=c+makePoint(x,y,1.9,1.3,0.4,0.4,time);
   c=c+makePoint(x,y,0.8,0.9,0.4,0.5,time);
   c=c+makePoint(x,y,1.2,1.7,0.6,0.3,time);
   c=c+makePoint(x,y,0.3,0.6,0.5,0.4,time);
   c=c+makePoint(x,y,0.3,0.3,0.4,0.4,time);
   c=c+makePoint(x,y,1.4,0.8,0.4,0.5,time);
   c=c+makePoint(x,y,0.2,0.6,0.6,0.3,time);
   c=c+makePoint(x,y,1.3,0.5,0.5,0.4,time);
   c=c+makePoint(x,y,1.3,0.5,0.5,0.4,time);
   c=c+makePoint(x,y,0.3,0.7,0.1,0.2,time);
   
   vec3 d=vec3(a,b,c)/30.0;
   
   gl_FragColor = vec4(d.x,d.y,d.z,1.0);
}